<!-- 课程详情页访问 BertramChen -->
<template>
  <div class="userBehaviorCourseDetailContent" id="test">
    <div>test</div>
  </div>
</template>

<script>
export default {
  name: 'userBehaviorCourseDetail',
  apiData: {
    userPlayBehavior: '/dengta/user/action/courseDetail/visit.json'  //课程详情访问数据
  },
  //课程详情页访问数据
  courseDetailData: {
    courseId: 0,  //课程id
    channel: 10001, //访问渠道
    stayTime: 0,  //整个页面停留时长 毫秒
    slideStayPosition: [0,0,0,0],  //滑动停留的位置（数组） 详情，目录，评价，推荐,可为空
    slideStayTime: 0,  //滑动停留的时间 毫秒
    playIntroVideo: 0, //是否播放介绍动画
    playIntroTime: 0, //介绍动画播放时长（不包含暂停）
    clickBuy: 0,  //是否点击购买
    orderId: '', //订单id，可为空
    clickRecommend: 0,  //是否点击推荐
    recommendCourseId: '',  //推荐课程id，可为空
    courseDetailType: 0,  //页面类型  0 课程详情 1 拼团页
    xqTimer: null,
    mlTimer: null,
    pjTimer: null,
    tjTimer: null,
    pageTimer: null,
    slideTimer: null,
    xqTime: 0,  //详情滑动停留时间
    mlTime: 0,  //目录滑动停留时间
    pjTime: 0,  //评价滑动停留时间
    tjTime: 0,  //推荐滑动停留时间
    slideStay: [{"pos":"详情","posId":1,"time":"0"},{"pos":"目录","posId":2,"time":"0"},{"pos":"评价","posId":3,"time":"0"},{"pos":"推荐","posId":4,"time":"0"}]
  },
  //接口方法
  courseDetailVisit: function() {
    var that = this
    $.get(that.apiData.userPlayBehavior, {
      courseId: that.courseDetailData.courseId,
      channel: that.courseDetailData.channel,
      stayTime: that.courseDetailData.stayTime,
      // slideStayPosition: that.courseDetailData.slideStayPosition[0] + ',' + that.courseDetailData.slideStayPosition[1] + ',' + that.courseDetailData.slideStayPosition[2] + ',' + that.courseDetailData.slideStayPosition[3],
      // slideStayTime: that.courseDetailData.xqTime + ',' + that.courseDetailData.mlTime + ',' + that.courseDetailData.pjTime + ',' + that.courseDetailData.tjTime,
      playIntroVideo: that.courseDetailData.playIntroVideo,
      playIntroTime: Math.round(that.courseDetailData.playIntroTime),
      clickBuy: that.courseDetailData.clickBuy,
      orderId: that.courseDetailData.orderId,
      clickRecommend: that.courseDetailData.clickRecommend,
      recommendCourseId: that.courseDetailData.recommendCourseId,
      courseDetailType: that.courseDetailData.courseDetailType,
      slideStay: JSON.stringify(that.courseDetailData.slideStay)
    })
  },
  //初始化
  init: function() {
    window.gCourseTJData=this.courseDetailData
    this.courseDetailData=window.gCourseTJData
    ApiHelper.courseDetails && this.initCourseDetails()
  },
  //课程详情页
  initCourseDetails: function() {
    var that = this
    //停留在详情tabbar
    ApiHelper.$on('stayInXQ', function(e, data) {
      that.courseDetailData.slideStayPosition[0] = 1
      console.log(that.courseDetailData.slideStayPosition)
      clearInterval(that.courseDetailData.xqTimer)
      clearInterval(that.courseDetailData.mlTimer)
      clearInterval(that.courseDetailData.tjTimer)
      clearInterval(that.courseDetailData.pjTimer)
      that.courseDetailData.xqTimer = setInterval(function() {
        that.courseDetailData.xqTime += 100
        that.courseDetailData.slideStay[0].time = that.courseDetailData.xqTime
      }, 100)
    })
    //停留在目录tabbar
    ApiHelper.$on('stayInML', function(e, data) {
      that.courseDetailData.slideStayPosition[1] = 1
      console.log(that.courseDetailData.slideStayPosition)
      clearInterval(that.courseDetailData.xqTimer)
      clearInterval(that.courseDetailData.mlTimer)
      clearInterval(that.courseDetailData.tjTimer)
      clearInterval(that.courseDetailData.pjTimer)
      that.courseDetailData.mlTimer = setInterval(function() {
        that.courseDetailData.mlTime += 100
        that.courseDetailData.slideStay[1].time = that.courseDetailData.mlTime
      }, 100)
    })
    //停留在评价tabbar
    ApiHelper.$on('stayInPJ', function(e, data) {
      that.courseDetailData.slideStayPosition[2] = 1
      console.log(that.courseDetailData.slideStayPosition)
      clearInterval(that.courseDetailData.xqTimer)
      clearInterval(that.courseDetailData.mlTimer)
      clearInterval(that.courseDetailData.tjTimer)
      clearInterval(that.courseDetailData.pjTimer)
      that.courseDetailData.pjTimer = setInterval(function() {
        that.courseDetailData.pjTime += 100
        that.courseDetailData.slideStay[2].time = that.courseDetailData.pjTime
      }, 100)
    })
    //停留在推荐tabbar
    ApiHelper.$on('stayInTJ', function(e, data) {
      that.courseDetailData.slideStayPosition[3] = 1
      console.log(that.courseDetailData.slideStayPosition)
      clearInterval(that.courseDetailData.xqTimer)
      clearInterval(that.courseDetailData.mlTimer)
      clearInterval(that.courseDetailData.tjTimer)
      clearInterval(that.courseDetailData.pjTimer)
      that.courseDetailData.tjTimer = setInterval(function() {
        that.courseDetailData.tjTime += 100
        that.courseDetailData.slideStay[3].time = that.courseDetailData.tjTime
      }, 100)
    })
    //获取用户是否点击购买
    ApiHelper.$on('updateClickBuy', function() {
      that.courseDetailData.clickBuy = 1
    })
    //获取用户是否点击推荐
    ApiHelper.$on('updateClickRecommend', function(e, data) {
      that.courseDetailData.clickRecommend = 1
      that.courseDetailData.recommendCourseId = data.reCoId
      // that.courseDetailVisit()
    })
    //获取预告片(音频/视频)播放相关数据
    ApiHelper.$on('getTrailerVideoInfo', function(e, data) {
      var videoPlayer = null
      var ap = null
      var playIntroTimer = null //动画播放定时器
      if(data.mType) {//流媒体类型,1:视频,0:音频
        videoPlayer = data.videoPlayer
        videoPlayer.on('play', function() {
          that.courseDetailData.playIntroVideo = 1
          clearInterval(playIntroTimer)
          playIntroTimer = setInterval(function() {
            that.courseDetailData.playIntroTime += 100
          }, 100)
        })
        videoPlayer.on('pause', function() {
          clearInterval(playIntroTimer)
        })
        videoPlayer.on('ended', function() {
          clearInterval(playIntroTimer)
        })
      } else {
        ap = data.ap
        ap.on('play', function() {
          that.courseDetailData.playIntroVideo = 1
          clearInterval(playIntroTimer)
          playIntroTimer = setInterval(function() {
            that.courseDetailData.playIntroTime += 100
          }, 100)
        })
        ap.on('pause', function() {
          clearInterval(playIntroTimer)
        })
        ap.on('ended', function() {
          clearInterval(playIntroTimer)
        })
      }
    })
    //获取页面访问数据
    ApiHelper.$on('getPageInfo', function(e, data) {
      var stayTimer = null
      clearInterval(stayTimer)
      that.courseDetailData.channel = data.channel
      that.courseDetailData.courseId = data.courseId
      that.courseDetailData.courseDetailType = data.courseDetailType
      stayTimer = setInterval(function() {
        that.courseDetailData.stayTime += 100
      }, 100)
    })
    
    //获取订单id
    ApiHelper.$on('getOrderId', function(e, data) {
      that.courseDetailData.orderId = data.orderId
    })
    //用户访问数据统计
    ApiHelper.$on('submitUserVisitData', function(e, data) {
      that.courseDetailVisit()
    })
  }
}
</script>

<style lang="less" scoped>
.userBehaviorCourseDetailContent{}
</style>